(function () {
    "use strict";

    openerp.eiru_tools = {};

    openerp.eiru_tools.EiruToolsWidget = openerp.Widget.extend({
        template: 'eiru_tools.ToolsContainer',
        init: function (parent) {
            this._super(parent);
            this.start();
        },
        start: function () {
            console.log('started');
        }
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            do_show: function (options) {
                if (options instanceof Object) {
                    console.log(this);
                    this.$el.find('.oe_form_sheet').prepend('<button class="oe_button oe_button_highlight">Clickme</button>');
                }
                return this._super.apply(this, arguments);
            }
        });
    }

    if (openerp.web && openerp.web.ListView) {
        openerp.web.ListView.include({
            do_select: function () {
                var sidebar = this.sidebar.$el.find('.oe_sidebar');

                if (this.get_selected_ids().length) {
                    sidebar.append('<button class="oe_button oe_highlight">Clickme</button>');
                } else {
                    sidebar.find('.oe_button').remove();
                }

                return this._super.apply(this, arguments);
            }
        });
    }

    if (openerp.web && openerp.web.Sidebar) {
        openerp.web.Sidebar.include({
            start: function () {
                // console.log(this);
                return this._super.apply(this, arguments);
            }
        });
    }

    if (openerp.web && openerp.web.WebClient) {
        openerp.web.WebClient.include({
            show_application: function () {
                var button = new openerp.eiru_tools.EiruToolsWidget(this);
                button.appendTo(openerp.client.$el);
                return this._super.apply(this, arguments);
            }
        });
    }
})();
